function [comprimento_c,comprimento_d]=conversao

%matlabpool

%constantes
zlinha = complex(0.190,0.387) %impedancia da linha
vlinha = 380; %tensao de linha
fp = 0.8; % fator de potência indutivo
pot_aparente = 1e9; % pot aparente total do gerador
perda = 0.05 % perda na linha


%questão a
vfase = vlinha/sqrt(3); %tensao de fase
pot_ativa = pot_aparente*cos(-acos(fp)); %potencia ativa gerador
ztotal = vfase^2/(pot_ativa*perda/3);
comprimento_a = ztotal/real(zlinha)

%questao b. mesma coisa do item anterior, com tensão de linha de 13.8kV
vfase2 = 13.8e3/sqrt(3);
ztotal = vfase2^2/(pot_ativa*perda/3);
comprimento_b = ztotal/real(zlinha)

%questao c/d
vfase3 = 500e3/sqrt(3);
fp2 = 0.92;
pot_ativa2 = pot_aparente*cos(-acos(fp2)); %potencia ativa gerador
comprimento_c = zeros(1,1); %vetores para armazenamento das distancias
comprimento_d = zeros(1,1); %vetores para armazenamento das distancias

for tensaoVar = floor(vfase2):1:ceil(vfase3)
    %referente a questão c
    ztotal = tensaoVar^2/(pot_ativa*perda/3);
    comprimento_c(tensaoVar-floor(vfase2)+1) = ztotal/real(zlinha);
    
    %referente a questao d
    ztotal2 = tensaoVar^2/(pot_ativa2*perda/3);
    comprimento_d(tensaoVar-floor(vfase2)+1) = ztotal2/real(zlinha);        
end

tensoes = floor(vfase2):1:ceil(vfase3);

plot(tensoes,comprimento_c); hold
plot(tensoes,comprimento_d);


end

