function [tensoes,comprimento_c,comprimento_d]=conversao2

%constantes
zlinha = complex(0.190,0.387) %impedancia da linha
vlinha = 380; %tensao de linha
fp = 0.8; % fator de potência indutivo
pot_aparente = 1e9; % pot aparente total do gerador
perda = 0.05 % perda na linha


%questão a
mod_vfase = 380/sqrt(3);
vfase = complex(cos(-acos(fp))*mod_vfase,sin(-acos(fp))*mod_vfase) %tensao de fase
imax = conj((pot_aparente/3)/vfase);
pot_ativa = pot_aparente*cos(-acos(fp))/3;
comprimento_a = (pot_ativa*perda)/(real(zlinha)*abs(imax)^2)

%questão b
mod_vfase2 = 13.8e3/sqrt(3);
vfase2 = complex(cos(-acos(fp))*mod_vfase2,sin(-acos(fp))*mod_vfase2) %tensao de fase
imax = conj((pot_aparente/3)/vfase2);
pot_ativa = pot_aparente*cos(-acos(fp))/3;
comprimento_b = (pot_ativa*perda)/(real(zlinha)*abs(imax)^2)

%questao c/d
mod_vfase3 = 500e3/sqrt(3);
fp2 = 0.92;
pot_ativa2 = pot_aparente*cos(-acos(fp2))/3; %potencia ativa gerador
comprimento_c = zeros(1,1); %vetores para armazenamento das distancias
comprimento_d = zeros(1,1); %vetores para armazenamento das distancias

for tensaoVar = floor(mod_vfase2):1:ceil(mod_vfase3);
    
    %questao c
    vfaseN = complex(cos(-acos(fp))*tensaoVar,sin(-acos(fp))*tensaoVar); %tensao de fase
    imax = conj((pot_aparente/3)/vfaseN);
    comprimento_c(tensaoVar-floor(mod_vfase2)+1) = (pot_ativa*perda)/(real(zlinha)*abs(imax)^2);

    
    %questao d
    vfaseN = complex(cos(-acos(fp2))*tensaoVar,sin(-acos(fp2))*tensaoVar); %tensao de fase
    imax = conj((pot_aparente/3)/vfaseN);
    comprimento_d(tensaoVar-floor(mod_vfase2)+1) = (pot_ativa2*perda)/(real(zlinha)*abs(imax)^2);
                
end

%plotagem
tensoes = floor(mod_vfase2):1:ceil(mod_vfase3); % tensoes

h = figure;
plot(tensoes,comprimento_c); hold
plot(tensoes,comprimento_d);
saveas(h,'figure.fig','fig');

end