%simulacao 2 de conversao

format('long'); %melhorar apresentacao dos numeros

%questão 1
%transformador
potencia = 60e3;
valta = 2300;
vbaixa = 230;
req1alta = 0.60;
req2baixa = 6e-3;
a = 2300/230;

%dados ensaios
%circuito aberto
vca = 230;
ica = 5.7;
pca = 190;

%curto circuito
vcc = 41.5;
icc = potencia/valta;

%dados em pu

%ensaio ca, lado de baixa tensao, secundário
sbase2 = 60e3;
vbase2 = vbaixa;
ibase2 = sbase2/vbase2
vcapu = vca/vbase2
icapu = ica/ibase2
pcapu = pca/sbase2
zbase2 = vbase2/ibase2


%ensaio cc, lado de alta tensao, primário
sbase1 = potencia;
vbase1 = valta;
ibase1 = sbase1/vbase1
iccpu = icc/ibase1
vccpu = vcc/vbase1
zbase1 = vbase1/ibase1

%cálculos das impedancias
%% core losses. medido a partir do ensaio de ca
rnpu = (vcapu^2)/pcapu
xnpu = vcapu/(sqrt(icapu^2-(vcapu/rnpu)^2))

%% copper losses, medido a partir do ensaio de cc
sbase1 = potencia;
req1pu = req1alta*2/zbase1
req2pu = req2baixa/zbase2
zeq1pu = vccpu/iccpu
xeq1pu = sqrt(zeq1pu^2-req1pu^2)

%questão 2
%%situacao a) fp = 0.6 indutivo
fp1 = 0.6;
fp2 = 1;
fp3 = 0.6;
pcore = pcapu %perda no núcleo
controle = 0;
for carga=0:0.01:100
    controle = controle+1;
    pcobre = req1pu*((carga/100)*iccpu)^2; %perda no cobre
    
    %curva 1
    pout1 = 1*(carga/100)*fp1;
    n1(controle) = pout1/(pout1+pcore+pcobre);
    
    %curva 2
    pout2 = 1*(carga/100)*fp2;
    n2(controle) = pout2/(pout2+pcore+pcobre);
    
    %curva 3
    pout3 = 1*(carga/100)*fp2;
    n3(controle) = pout3/(pout3+pcore+pcobre);
end


figure(1)
x = 0:0.01:100;
plot(x,n1*100,x,n2*100)
grid;
title('Rendimento do transformador X Carga Nominal');
xlabel('Carga (%)');
ylabel('Rendimento  (%)');

%questão 3
fp = 0.6;
theta1 = -acos(0.6);
theta2 = acos(1.0);
theta3 = acos(0.6);
controle = 0;
for carga=0:0.01:100
    controle = controle+1;
    zeqcomplexpu = complex(req1pu,xeq1pu);
    
    %curva 1
    corrente1 = complex(iccpu*cos(theta1),iccpu*sin(theta1));
    v11 = 1+zeqcomplexpu*corrente1*carga/100;
    regulacao1(controle) = abs(v11)-1;
    
    %curva 2
    corrente2 = complex(iccpu*cos(theta2),iccpu*sin(theta2));
    v12 = 1+zeqcomplexpu*corrente2*carga/100;
    regulacao2(controle) = abs(v12)-1;
    
    %curva 3
    corrente3 = complex(iccpu*cos(theta3),iccpu*sin(theta3));
    v13 = 1+zeqcomplexpu*corrente3*carga/100;
    regulacao3(controle) = abs(v13)-1;
 
end

figure(2)
x = 0:0.01:100;
plot(x,regulacao1*100,x,regulacao2*100,x,regulacao3*100);
grid;
title('Regulação de Tensão X Carga Nominal');
xlabel('Carga (%)');
ylabel('Regulação  (%)');




