%simulacao 2 de conversao

tic; %inicia cronometro
format('long'); %melhorar apresentacao dos numeros
clear variables; %limpa o workspace por segurança

%questão 1
%transformador
potencia = 60e3;
valta = 2300;
vbaixa = 230;
req1alta = 0.60;
req2baixa = 6e-3;
a = 2300/230;

%dados ensaios
%circuito aberto
vca = 230;
ica = 5.7;
pca = 190;

%curto circuito
vcc = 41.5;
icc = potencia/valta;

%dados em pu

%ensaio ca, lado de baixa tensao, secundário
sbase2 = 60e3;
vbase2 = vbaixa;
ibase2 = sbase2/vbase2
vcapu = vca/vbase2
icapu = ica/ibase2
pcapu = pca/sbase2
zbase2 = vbase2/ibase2


%ensaio cc, lado de alta tensao, primário
sbase1 = potencia;
vbase1 = valta;
ibase1 = sbase1/vbase1
iccpu = icc/ibase1
vccpu = vcc/vbase1
zbase1 = vbase1/ibase1

%cálculos das impedancias
%% core losses. medido a partir do ensaio de ca
rnpu = (vcapu^2)/pcapu
xnpu = vcapu/(sqrt(icapu^2-(vcapu/rnpu)^2))

%% copper losses, medido a partir do ensaio de cc
sbase1 = potencia;
req1pu = req1alta*2/zbase1
req2pu = req2baixa/zbase2
zeq1pu = vccpu/iccpu
xeq1pu = sqrt(zeq1pu^2-req1pu^2)

%questão 2
%%situacao a) fp = 0.6 indutivo
fp1 = 0.6;
fp2 = 1;
fp3 = 0.6;
theta1 = -acos(0.6);
theta2 = acos(1.0);
theta3 = acos(0.6);
controle = 0;
n1 = zeros(1,1);
n2 = zeros(1,1);
n3 = zeros(1,1);
zeqcomplexpu = complex(req1pu,xeq1pu);
for carga=0:1:100
    controle = controle+1;    
    
    %curva 1
    syms v11;
    v11t = solve((v11-1)/zeqcomplexpu+v11/(1/((1/rnpu)+(1/xnpu)))-complex(cos(theta1)*carga/100,sin(theta1)*carga/100),v11);
    v11n = abs(eval(v11t));
    perdas = v11n^2/rnpu + abs(((v11n-1)/zeqcomplexpu))^2*req1pu;
    pout1 = fp1*carga/100;
    n1(controle) = pout1/(pout1+perdas);
    
    %curva 2
    syms v12;
    v12t = solve((v12-1)/zeqcomplexpu+v12/(1/((1/rnpu)+(1/xnpu)))-complex(cos(theta2)*carga/100,sin(theta2)*carga/100),v12);
    v12n = abs(eval(v12t));
    perdas = v12n^2/rnpu + abs(((v12n-1)/zeqcomplexpu))^2*req1pu;
    pout2 = fp2*carga/100;
    n2(controle) = pout2/(pout2+perdas);
    
     %curva 3
    syms v13;
    v13t = solve((v13-1)/zeqcomplexpu+v13/(1/((1/rnpu)+(1/xnpu)))-complex(cos(theta3)*carga/100,sin(theta3)*carga/100),v13);
    v13n = abs(eval(v13t));
    perdas = v13n^2/rnpu + abs(((v13n-1)/zeqcomplexpu))^2*req1pu;
    pout3 = fp3*carga/100;
    n3(controle) = pout3/(pout3+perdas);   


end


figure(6)
x = 0:1:100;
plot(x,n1*100,x,n2*100,x,n3*100)
grid;
title('Rendimento do transformador X Carga Nominal');
xlabel('Carga (%)');
ylabel('Rendimento  (%)');
legend('fp = 0.6 indutivo', 'fp = 1', 'fp = 0.6 capacitivo');

%questão 3
fp = 0.6;
theta1 = -acos(0.6);
theta2 = acos(1.0);
theta3 = acos(0.6);
controle = 0;
zeqcomplexpu = complex(req1pu,xeq1pu);
regulacao1 = zeros(1,1);
regulacao2 = zeros(1,1);
regulacao3 = zeros(1,1);
for carga=0:0.1:100
    controle = controle+1;
    
    
    %curva 1
    syms v11;
    v11t = solve((v11-1)/zeqcomplexpu+v11/(1/((1/rnpu)+(1/xnpu)))-complex(cos(theta1)*carga/100,sin(theta1)*carga/100),v11);
    regulacao1(controle) = abs(eval(v11t))-1;
    
    %curva 2
    syms v12;
    v12t = solve((v12-1)/zeqcomplexpu+v12/(1/((1/rnpu)+(1/xnpu)))-complex(cos(theta2)*carga/100,sin(theta2)*carga/100),v12);
    regulacao2(controle) = abs(eval(v12t))-1;
    
    %curva 3
    syms v13;
    v13t = solve((v13-1)/zeqcomplexpu+v13/(1/((1/rnpu)+(1/xnpu)))-complex(cos(theta3)*carga/100,sin(theta3)*carga/100),v13);
    regulacao3(controle) = abs(eval(v13t))-1;
end

figure(5)
length(regulacao1)
x = 0:0.1:100;
plot(x,regulacao1*100,x,regulacao2*100,x,regulacao3*100);
grid;
title('Regulação de Tensão X Carga Nominal');
xlabel('Carga (%)');
ylabel('Regulação  (%)');
legend('fp = 0.6 indutivo', 'fp = 1', 'fp = 0.6 capacitivo');
tempo = toc; %para cronometro