%simulacao 2 de conversao

tic; %inicia cronometro
format('long'); %melhorar apresentacao dos numeros
clear variables; %limpa as variaveis do workspace por seguranca

%matlabpool %iniciar os workes para paralelizar o codigo

%questão 1
%transformador
potencia = 60e3;
valta = 2300;
vbaixa = 230;
req1alta = 0.60;
req2baixa = 6e-3;
a = 2300/230;

%dados ensaios
%circuito aberto
vca = 230;
ica = 5.7;
pca = 190;

%curto circuito
vcc = 41.5;
icc = potencia/valta;

%dados em pu

%ensaio ca, lado de baixa tensao, secundário
sbase2 = 60e3;
vbase2 = vbaixa;
ibase2 = sbase2/vbase2
vcapu = vca/vbase2
icapu = ica/ibase2
pcapu = pca/sbase2
zbase2 = vbase2/ibase2


%ensaio cc, lado de alta tensao, primário
sbase1 = potencia;
vbase1 = valta;
ibase1 = sbase1/vbase1
iccpu = icc/ibase1
vccpu = vcc/vbase1
zbase1 = vbase1/ibase1

%cálculos das impedancias
%% core losses. medido a partir do ensaio de ca
rnpu = (vcapu^2)/pcapu
xnpu = vcapu/(sqrt(icapu^2-(vcapu/rnpu)^2))

%% copper losses, medido a partir do ensaio de cc
sbase1 = potencia;
req1pu = req1alta*2/zbase1
req2pu = req2baixa/zbase2
zeq1pu = vccpu/iccpu
xeq1pu = sqrt(zeq1pu^2-req1pu^2)

%questão 2
%%situacao a) fp = 0.6 indutivo
fp1 = 0.6;
fp2 = 1;
fp3 = 0.6;
theta1 = -acos(0.6);
theta2 = acos(1.0);
theta3 = acos(0.6);
n1 = zeros(1,1);
n2 = zeros(1,1);
n3 = zeros(1,1);
zeqcomplexpu = complex(req1pu,xeq1pu);
parfor carga=0:100        
    %curva 1
    y = complex(cos(theta1)*carga/100,sin(theta1)*carga/100);
    v11 = rnpu * xnpu * (y * req1pu + (1i) * y * xeq1pu + 1) / (rnpu * xnpu - xnpu * req1pu + (-1*1i) * xnpu * xeq1pu + (1i) * rnpu * req1pu - rnpu * xeq1pu);
    v11n = abs(v11);
    perdas = v11n^2/rnpu + abs(((1-v11n)/zeqcomplexpu))^2*req1pu;
    pout1 = fp1*carga/100;
    n1(carga+1) = pout1/(pout1+perdas);
end

parfor carga=0:100
    %curva 2
    y = complex(cos(theta2)*carga/100,sin(theta2)*carga/100);
    v12 = rnpu * xnpu * (y * req1pu + (1i) * y * xeq1pu + 1) / (rnpu * xnpu - xnpu * req1pu + (-1*1i) * xnpu * xeq1pu + (1i) * rnpu * req1pu - rnpu * xeq1pu);
    v12n = abs(v12);
    perdas = v12n^2/rnpu + abs(((1-v12n)/zeqcomplexpu))^2*req1pu;
    pout2 = fp2*carga/100;
    n2(carga+1) = pout2/(pout2+perdas);
end

parfor carga=0:100
    %curva 3
    y = complex(cos(theta3)*carga/100,sin(theta3)*carga/100);
    v13 = rnpu * xnpu * (y * req1pu + (1i) * y * xeq1pu + 1) / (rnpu * xnpu - xnpu * req1pu + (-1*1i) * xnpu * xeq1pu + (1i) * rnpu * req1pu - rnpu * xeq1pu);
    v13n = abs(v13);
    perdas = v13n^2/rnpu + abs(((1-v13n)/zeqcomplexpu))^2*req1pu;
    pout3 = fp3*carga/100;
    n3(carga+1) = pout3/(pout3+perdas);   
end


figure(4)
x = 0:1:100;
plot(x,n1*100,x,n2*100,x,n3*100)
grid;
title('Rendimento do transformador X Carga Nominal');
xlabel('Carga (%)');
ylabel('Rendimento  (%)');
legend('fp = 0.6 indutivo', 'fp = 1', 'fp = 0.6 capacitivo');

%questão 3
fp = 0.6;
theta1 = -acos(0.6);
theta2 = acos(1.0);
theta3 = acos(0.6);
controle = 0;
zeqcomplexpu = complex(req1pu,xeq1pu);
regulacao1 = zeros(1,1);
regulacao2 = zeros(1,1);
regulacao3 = zeros(1,1);
parfor carga=0:100       
    %curva 1
    y = complex(cos(theta1)*carga/100,sin(theta1)*carga/100);
    v11 = rnpu * xnpu * (y * req1pu + (1i) * y * xeq1pu + 1) / (rnpu * xnpu - xnpu * req1pu + (-1*1i) * xnpu * xeq1pu + (1i) * rnpu * req1pu - rnpu * xeq1pu);
    v11n = abs(v11);
    regulacao1(carga+1) = (v11n-1)/1;
end
   
parfor carga=0:100
    %curva 2
    y = complex(cos(theta2)*carga/100,sin(theta2)*carga/100);
    v12 = rnpu * xnpu * (y * req1pu + (1i) * y * xeq1pu + 1) / (rnpu * xnpu - xnpu * req1pu + (-1*1i) * xnpu * xeq1pu + (1i) * rnpu * req1pu - rnpu * xeq1pu);
    v12n = abs(v12);
    regulacao2(carga+1) = (v12n-1)/1;
end
   
parfor carga=0:100
    %curva 3
    y = complex(cos(theta3)*carga/100,sin(theta3)*carga/100);
    v13 = rnpu * xnpu * (y * req1pu + (1i) * y * xeq1pu + 1) / (rnpu * xnpu - xnpu * req1pu + (-1*1i) * xnpu * xeq1pu + (1i) * rnpu * req1pu - rnpu * xeq1pu);
    v13n = abs(v13);
    regulacao3(carga+1) = (v13n-1)/1;
end

figure(3)
x = 0:100;
plot(x,regulacao1*100,x,regulacao2*100,x,regulacao3*100);
grid;
title('Regulação de Tensão X Carga Nominal');
xlabel('Carga (%)');
ylabel('Regulação  (%)');
legend('fp = 0.6 indutivo', 'fp = 1', 'fp = 0.6 capacitivo');
tempo = toc; %para cronometro
